// Written by Yanko
// Modified by TeTeT

params [ ["_radar", player], ["_short_range", 5000], ["_long_range", 10000], ["_refresh", 1], ["_updateFreq", 10] ];

private ["_marker", "_objects", "_markery", "_i", "_j", "_unit", "_dist", "_objName", "_cfg"];

// guard
player setVariable ["TTT_radar", true];

//display range of radar

_marker = createMarkerLocal ["shortRange", position _radar];
_marker setMarkerShapeLocal "ELLIPSE";
_marker setMarkerSizeLocal [_short_range, _short_range];
_marker setMarkerColorLocal "ColorRed";
_marker setMarkerAlphaLocal 0.5;

_marker = createMarkerLocal ["longRange", position _radar];
_marker setMarkerShapeLocal "ELLIPSE";
_marker setMarkerSizeLocal [_long_range, _long_range];
_marker setMarkerColorLocal "ColorGreen";
_marker setMarkerAlphaLocal 0.5;

//main loop

systemChat "Radar script started";

while {alive player and !isNil{player getVariable "TTT_radar"}} do {

   //create marker matrix
   _objects = (position _radar) nearEntities [["Air"], _long_range];

   _markery = [];
      {
      _marker = createMarkerLocal [format ["m%1",_x], position _x];
      _marker setMarkerShapeLocal "ICON";
      _marker setMarkerTypeLocal "mil_dot";
      if (side _x == side player) then {
         _marker setMarkerColorLocal "COLORBLUE";
      } else {
         _marker setMarkerColorLocal "COLORRED";
      };
      _markery pushBack _marker;
   } forEach _objects;

   //update position of markers
   _j = 0;
   while {_j < _updateFreq} do {

      {
         _unit = _objects select _forEachIndex;
         _cfg = (configFile >> "CfgVehicles" >> typeOf _unit);
         _objName = getText(_cfg >> "displayName");

         _x setMarkerPosLocal getPos _unit;

         if (terrainIntersectASL [getPosASL _radar, getPosASL _unit]) then {
            _x setMarkerAlphaLocal 0;
         } else {
            _dist = _radar distance _unit;
            if ( _dist < _long_range and _dist >= _short_range ) then {
               _x setMarkerTextlocal format ["%1", _objName];
            };
            if ( _dist < _short_range ) then {
               _x setMarkerTextlocal format ["%1 A:%2 S:%3 DIR:%4", _objName, round(getPosASL _unit select 2), round speed _unit, round getdir _unit];
            };
            if ( _dist >= _long_range) then {
               _x setMarkerAlphaLocal 0;
            };
         };
      } forEach _markery;
      sleep _refresh;
      _j =_j + 1;
   };

   //clear markers and objects matrix for reassign all air units in radar range

   {
      deleteMarkerLocal _x;
   } forEach _markery;
   _marker = nil;
   _objects = nil;
   _markery = nil;
};

deleteMarkerLocal "shortRange";
deleteMarkerLocal "longRange";

systemChat "Radar script stopped";
player setVariable ["TTT_radar", nil];